{
  This file was automatically generated on 2024-04-08.

  Delphi/Lazarus Bindings Version 2.1.34

  If you have a bugfix for this file and want to commit it,
  please fix the bug in the generator. You can find a link
  to the generators git on tinkerforge.com
}

unit BrickletBarometer;

{$ifdef FPC}{$mode OBJFPC}{$H+}{$endif}

interface

uses
  Device, IPConnection, LEConverter, Math, SyncObjs;

const
  BRICKLET_BAROMETER_DEVICE_IDENTIFIER = 221;
  BRICKLET_BAROMETER_DEVICE_DISPLAY_NAME = 'Barometer Bricklet';

  BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE = 1;
  BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE = 2;
  BRICKLET_BAROMETER_FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD = 3;
  BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD = 4;
  BRICKLET_BAROMETER_FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD = 5;
  BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD = 6;
  BRICKLET_BAROMETER_FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD = 7;
  BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD = 8;
  BRICKLET_BAROMETER_FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD = 9;
  BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD = 10;
  BRICKLET_BAROMETER_FUNCTION_SET_DEBOUNCE_PERIOD = 11;
  BRICKLET_BAROMETER_FUNCTION_GET_DEBOUNCE_PERIOD = 12;
  BRICKLET_BAROMETER_FUNCTION_SET_REFERENCE_AIR_PRESSURE = 13;
  BRICKLET_BAROMETER_FUNCTION_GET_CHIP_TEMPERATURE = 14;
  BRICKLET_BAROMETER_FUNCTION_GET_REFERENCE_AIR_PRESSURE = 19;
  BRICKLET_BAROMETER_FUNCTION_SET_AVERAGING = 20;
  BRICKLET_BAROMETER_FUNCTION_GET_AVERAGING = 21;
  BRICKLET_BAROMETER_FUNCTION_SET_I2C_MODE = 22;
  BRICKLET_BAROMETER_FUNCTION_GET_I2C_MODE = 23;
  BRICKLET_BAROMETER_FUNCTION_GET_IDENTITY = 255;

  BRICKLET_BAROMETER_CALLBACK_AIR_PRESSURE = 15;
  BRICKLET_BAROMETER_CALLBACK_ALTITUDE = 16;
  BRICKLET_BAROMETER_CALLBACK_AIR_PRESSURE_REACHED = 17;
  BRICKLET_BAROMETER_CALLBACK_ALTITUDE_REACHED = 18;

  BRICKLET_BAROMETER_THRESHOLD_OPTION_OFF = 'x';
  BRICKLET_BAROMETER_THRESHOLD_OPTION_OUTSIDE = 'o';
  BRICKLET_BAROMETER_THRESHOLD_OPTION_INSIDE = 'i';
  BRICKLET_BAROMETER_THRESHOLD_OPTION_SMALLER = '<';
  BRICKLET_BAROMETER_THRESHOLD_OPTION_GREATER = '>';
  BRICKLET_BAROMETER_I2C_MODE_FAST = 0;
  BRICKLET_BAROMETER_I2C_MODE_SLOW = 1;

type
  TArray0To2OfUInt8 = array [0..2] of byte;

  TBrickletBarometer = class;
  TBrickletBarometerNotifyAirPressure = procedure(sender: TBrickletBarometer; const airPressure: longint) of object;
  TBrickletBarometerNotifyAltitude = procedure(sender: TBrickletBarometer; const altitude: longint) of object;
  TBrickletBarometerNotifyAirPressureReached = procedure(sender: TBrickletBarometer; const airPressure: longint) of object;
  TBrickletBarometerNotifyAltitudeReached = procedure(sender: TBrickletBarometer; const altitude: longint) of object;

  /// <summary>
  ///  Measures air pressure and altitude changes
  /// </summary>
  TBrickletBarometer = class(TDevice)
  private
    airPressureCallback: TBrickletBarometerNotifyAirPressure;
    altitudeCallback: TBrickletBarometerNotifyAltitude;
    airPressureReachedCallback: TBrickletBarometerNotifyAirPressureReached;
    altitudeReachedCallback: TBrickletBarometerNotifyAltitudeReached;
  protected
    procedure CallbackWrapperAirPressure(const packet: TByteArray); virtual;
    procedure CallbackWrapperAltitude(const packet: TByteArray); virtual;
    procedure CallbackWrapperAirPressureReached(const packet: TByteArray); virtual;
    procedure CallbackWrapperAltitudeReached(const packet: TByteArray); virtual;
  public
    /// <summary>
    ///  Creates an object with the unique device ID <c>uid</c>. This object can
    ///  then be added to the IP connection.
    /// </summary>
    constructor Create(const uid: string; ipcon_: TIPConnection);

    /// <summary>
    ///  Returns the air pressure of the air pressure sensor.
    ///  
    ///  If you want to get the air pressure periodically, it is recommended to use the
    ///  <see cref="BrickletBarometer.TBrickletBarometer.OnAirPressure"/> callback and set the period with
    ///  <see cref="BrickletBarometer.TBrickletBarometer.SetAirPressureCallbackPeriod"/>.
    /// </summary>
    function GetAirPressure: longint; virtual;

    /// <summary>
    ///  Returns the relative altitude of the air pressure sensor. The value is
    ///  calculated based on the difference between the current air pressure
    ///  and the reference air pressure that can be set with <see cref="BrickletBarometer.TBrickletBarometer.SetReferenceAirPressure"/>.
    ///  
    ///  If you want to get the altitude periodically, it is recommended to use the
    ///  <see cref="BrickletBarometer.TBrickletBarometer.OnAltitude"/> callback and set the period with
    ///  <see cref="BrickletBarometer.TBrickletBarometer.SetAltitudeCallbackPeriod"/>.
    /// </summary>
    function GetAltitude: longint; virtual;

    /// <summary>
    ///  Sets the period with which the <see cref="BrickletBarometer.TBrickletBarometer.OnAirPressure"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  The <see cref="BrickletBarometer.TBrickletBarometer.OnAirPressure"/> callback is only triggered if the air pressure has
    ///  changed since the last triggering.
    /// </summary>
    procedure SetAirPressureCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletBarometer.TBrickletBarometer.SetAirPressureCallbackPeriod"/>.
    /// </summary>
    function GetAirPressureCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the period with which the <see cref="BrickletBarometer.TBrickletBarometer.OnAltitude"/> callback is triggered
    ///  periodically. A value of 0 turns the callback off.
    ///  
    ///  The <see cref="BrickletBarometer.TBrickletBarometer.OnAltitude"/> callback is only triggered if the altitude has changed since
    ///  the last triggering.
    /// </summary>
    procedure SetAltitudeCallbackPeriod(const period: longword); virtual;

    /// <summary>
    ///  Returns the period as set by <see cref="BrickletBarometer.TBrickletBarometer.SetAltitudeCallbackPeriod"/>.
    /// </summary>
    function GetAltitudeCallbackPeriod: longword; virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletBarometer.TBrickletBarometer.OnAirPressureReached"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the air pressure is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the air pressure is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the air pressure is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the air pressure is greater than the min value (max is ignored)"
    ///  </code>
    /// </summary>
    procedure SetAirPressureCallbackThreshold(const option: char; const min: longint; const max: longint); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletBarometer.TBrickletBarometer.SetAirPressureCallbackThreshold"/>.
    /// </summary>
    procedure GetAirPressureCallbackThreshold(out option: char; out min: longint; out max: longint); virtual;

    /// <summary>
    ///  Sets the thresholds for the <see cref="BrickletBarometer.TBrickletBarometer.OnAltitudeReached"/> callback.
    ///  
    ///  The following options are possible:
    ///  
    ///  <code>
    ///   "Option", "Description"
    ///  
    ///   "'x'",    "Callback is turned off"
    ///   "'o'",    "Callback is triggered when the altitude is *outside* the min and max values"
    ///   "'i'",    "Callback is triggered when the altitude is *inside* the min and max values"
    ///   "'&lt;'",    "Callback is triggered when the altitude is smaller than the min value (max is ignored)"
    ///   "'&gt;'",    "Callback is triggered when the altitude is greater than the min value (max is ignored)"
    ///  </code>
    /// </summary>
    procedure SetAltitudeCallbackThreshold(const option: char; const min: longint; const max: longint); virtual;

    /// <summary>
    ///  Returns the threshold as set by <see cref="BrickletBarometer.TBrickletBarometer.SetAltitudeCallbackThreshold"/>.
    /// </summary>
    procedure GetAltitudeCallbackThreshold(out option: char; out min: longint; out max: longint); virtual;

    /// <summary>
    ///  Sets the period with which the threshold callbacks
    ///  
    ///  * <see cref="BrickletBarometer.TBrickletBarometer.OnAirPressureReached"/>,
    ///  * <see cref="BrickletBarometer.TBrickletBarometer.OnAltitudeReached"/>
    ///  
    ///  are triggered, if the thresholds
    ///  
    ///  * <see cref="BrickletBarometer.TBrickletBarometer.SetAirPressureCallbackThreshold"/>,
    ///  * <see cref="BrickletBarometer.TBrickletBarometer.SetAltitudeCallbackThreshold"/>
    ///  
    ///  keep being reached.
    /// </summary>
    procedure SetDebouncePeriod(const debounce: longword); virtual;

    /// <summary>
    ///  Returns the debounce period as set by <see cref="BrickletBarometer.TBrickletBarometer.SetDebouncePeriod"/>.
    /// </summary>
    function GetDebouncePeriod: longword; virtual;

    /// <summary>
    ///  Sets the reference air pressure for the altitude calculation.
    ///  Setting the reference to the current air pressure results in a calculated
    ///  altitude of 0cm. Passing 0 is a shortcut for passing the current air pressure as
    ///  reference.
    ///  
    ///  Well known reference values are the Q codes
    ///  `QNH &lt;https://en.wikipedia.org/wiki/QNH&gt;`__ and
    ///  `QFE &lt;https://en.wikipedia.org/wiki/Mean_sea_level_pressure#Mean_sea_level_pressure&gt;`__
    ///  used in aviation.
    /// </summary>
    procedure SetReferenceAirPressure(const airPressure: longint); virtual;

    /// <summary>
    ///  Returns the temperature of the air pressure sensor.
    ///  
    ///  This temperature is used internally for temperature compensation of the air
    ///  pressure measurement. It is not as accurate as the temperature measured by the
    ///  :ref:`temperature_bricklet` or the :ref:`temperature_ir_bricklet`.
    /// </summary>
    function GetChipTemperature: smallint; virtual;

    /// <summary>
    ///  Returns the reference air pressure as set by <see cref="BrickletBarometer.TBrickletBarometer.SetReferenceAirPressure"/>.
    /// </summary>
    function GetReferenceAirPressure: longint; virtual;

    /// <summary>
    ///  Sets the different averaging parameters. It is possible to set
    ///  the length of a normal averaging for the temperature and pressure,
    ///  as well as an additional length of a
    ///  `moving average &lt;https://en.wikipedia.org/wiki/Moving_average&gt;`__
    ///  for the pressure. The moving average is calculated from the normal
    ///  averages.  There is no moving average for the temperature.
    ///  
    ///  Setting the all three parameters to 0 will turn the averaging
    ///  completely off. If the averaging is off, there is lots of noise
    ///  on the data, but the data is without delay. Thus we recommend
    ///  to turn the averaging off if the Barometer Bricklet data is
    ///  to be used for sensor fusion with other sensors.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    procedure SetAveraging(const movingAveragePressure: byte; const averagePressure: byte; const averageTemperature: byte); virtual;

    /// <summary>
    ///  Returns the averaging configuration as set by <see cref="BrickletBarometer.TBrickletBarometer.SetAveraging"/>.
    ///  
    ///  .. versionadded:: 2.0.1$nbsp;(Plugin)
    /// </summary>
    procedure GetAveraging(out movingAveragePressure: byte; out averagePressure: byte; out averageTemperature: byte); virtual;

    /// <summary>
    ///  Sets the I2C mode. Possible modes are:
    ///  
    ///  * 0: Fast (400kHz)
    ///  * 1: Slow (100kHz)
    ///  
    ///  If you have problems with obvious outliers in the
    ///  Barometer Bricklet measurements, they may be caused by EMI issues.
    ///  In this case it may be helpful to lower the I2C speed.
    ///  
    ///  It is however not recommended to lower the I2C speed in applications where
    ///  a high throughput needs to be achieved.
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    procedure SetI2CMode(const mode: byte); virtual;

    /// <summary>
    ///  Returns the I2C mode as set by <see cref="BrickletBarometer.TBrickletBarometer.SetI2CMode"/>.
    ///  
    ///  .. versionadded:: 2.0.3$nbsp;(Plugin)
    /// </summary>
    function GetI2CMode: byte; virtual;

    /// <summary>
    ///  Returns the UID, the UID where the Bricklet is connected to,
    ///  the position, the hardware and firmware version as well as the
    ///  device identifier.
    ///  
    ///  The position can be 'a', 'b', 'c', 'd', 'e', 'f', 'g' or 'h' (Bricklet Port).
    ///  A Bricklet connected to an :ref:`Isolator Bricklet &lt;isolator_bricklet&gt;` is always at
    ///  position 'z'.
    ///  
    ///  The device identifier numbers can be found :ref:`here &lt;device_identifier&gt;`.
    ///  |device_identifier_constant|
    /// </summary>
    procedure GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word); override;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletBarometer.TBrickletBarometer.SetAirPressureCallbackPeriod"/>. The parameter is the air
    ///  pressure of the air pressure sensor.
    ///  
    ///  The <see cref="BrickletBarometer.TBrickletBarometer.OnAirPressure"/> callback is only triggered if the air pressure has
    ///  changed since the last triggering.
    /// </summary>
    property OnAirPressure: TBrickletBarometerNotifyAirPressure read airPressureCallback write airPressureCallback;

    /// <summary>
    ///  This callback is triggered periodically with the period that is set by
    ///  <see cref="BrickletBarometer.TBrickletBarometer.SetAltitudeCallbackPeriod"/>. The parameter is the altitude of
    ///  the air pressure sensor.
    ///  
    ///  The <see cref="BrickletBarometer.TBrickletBarometer.OnAltitude"/> callback is only triggered if the altitude has changed since
    ///  the last triggering.
    /// </summary>
    property OnAltitude: TBrickletBarometerNotifyAltitude read altitudeCallback write altitudeCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletBarometer.TBrickletBarometer.SetAirPressureCallbackThreshold"/> is reached.
    ///  The parameter is the air pressure of the air pressure sensor.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletBarometer.TBrickletBarometer.SetDebouncePeriod"/>.
    /// </summary>
    property OnAirPressureReached: TBrickletBarometerNotifyAirPressureReached read airPressureReachedCallback write airPressureReachedCallback;

    /// <summary>
    ///  This callback is triggered when the threshold as set by
    ///  <see cref="BrickletBarometer.TBrickletBarometer.SetAltitudeCallbackThreshold"/> is reached.
    ///  The parameter is the altitude of the air pressure sensor.
    ///  
    ///  If the threshold keeps being reached, the callback is triggered periodically
    ///  with the period as set by <see cref="BrickletBarometer.TBrickletBarometer.SetDebouncePeriod"/>.
    /// </summary>
    property OnAltitudeReached: TBrickletBarometerNotifyAltitudeReached read altitudeReachedCallback write altitudeReachedCallback;
  end;

implementation

constructor TBrickletBarometer.Create(const uid: string; ipcon_: TIPConnection);
begin
  inherited Create(uid, ipcon_, BRICKLET_BAROMETER_DEVICE_IDENTIFIER, BRICKLET_BAROMETER_DEVICE_DISPLAY_NAME);
  apiVersion[0] := 2;
  apiVersion[1] := 0;
  apiVersion[2] := 2;

  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_DEBOUNCE_PERIOD] := DEVICE_RESPONSE_EXPECTED_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_DEBOUNCE_PERIOD] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_REFERENCE_AIR_PRESSURE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_CHIP_TEMPERATURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_REFERENCE_AIR_PRESSURE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_AVERAGING] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_AVERAGING] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_SET_I2C_MODE] := DEVICE_RESPONSE_EXPECTED_FALSE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_I2C_MODE] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;
  responseExpected[BRICKLET_BAROMETER_FUNCTION_GET_IDENTITY] := DEVICE_RESPONSE_EXPECTED_ALWAYS_TRUE;

  callbackWrappers[BRICKLET_BAROMETER_CALLBACK_AIR_PRESSURE] := {$ifdef FPC}@{$endif}CallbackWrapperAirPressure;
  callbackWrappers[BRICKLET_BAROMETER_CALLBACK_ALTITUDE] := {$ifdef FPC}@{$endif}CallbackWrapperAltitude;
  callbackWrappers[BRICKLET_BAROMETER_CALLBACK_AIR_PRESSURE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAirPressureReached;
  callbackWrappers[BRICKLET_BAROMETER_CALLBACK_ALTITUDE_REACHED] := {$ifdef FPC}@{$endif}CallbackWrapperAltitudeReached;

  (ipcon as TIPConnection).AddDevice(self);
end;

function TBrickletBarometer.GetAirPressure: longint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE, 8);
  response := SendRequest(request, 12);
  result := LEConvertInt32From(8, response);
end;

function TBrickletBarometer.GetAltitude: longint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE, 8);
  response := SendRequest(request, 12);
  result := LEConvertInt32From(8, response);
end;

procedure TBrickletBarometer.SetAirPressureCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_AIR_PRESSURE_CALLBACK_PERIOD, 12);
  LEConvertUInt32To(period, 8, request);
  SendRequest(request, 0);
end;

function TBrickletBarometer.GetAirPressureCallbackPeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE_CALLBACK_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletBarometer.SetAltitudeCallbackPeriod(const period: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_ALTITUDE_CALLBACK_PERIOD, 12);
  LEConvertUInt32To(period, 8, request);
  SendRequest(request, 0);
end;

function TBrickletBarometer.GetAltitudeCallbackPeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE_CALLBACK_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletBarometer.SetAirPressureCallbackThreshold(const option: char; const min: longint; const max: longint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_AIR_PRESSURE_CALLBACK_THRESHOLD, 17);
  LEConvertCharTo(option, 8, request);
  LEConvertInt32To(min, 9, request);
  LEConvertInt32To(max, 13, request);
  SendRequest(request, 0);
end;

procedure TBrickletBarometer.GetAirPressureCallbackThreshold(out option: char; out min: longint; out max: longint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_AIR_PRESSURE_CALLBACK_THRESHOLD, 8);
  response := SendRequest(request, 17);
  option := LEConvertCharFrom(8, response);
  min := LEConvertInt32From(9, response);
  max := LEConvertInt32From(13, response);
end;

procedure TBrickletBarometer.SetAltitudeCallbackThreshold(const option: char; const min: longint; const max: longint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_ALTITUDE_CALLBACK_THRESHOLD, 17);
  LEConvertCharTo(option, 8, request);
  LEConvertInt32To(min, 9, request);
  LEConvertInt32To(max, 13, request);
  SendRequest(request, 0);
end;

procedure TBrickletBarometer.GetAltitudeCallbackThreshold(out option: char; out min: longint; out max: longint);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_ALTITUDE_CALLBACK_THRESHOLD, 8);
  response := SendRequest(request, 17);
  option := LEConvertCharFrom(8, response);
  min := LEConvertInt32From(9, response);
  max := LEConvertInt32From(13, response);
end;

procedure TBrickletBarometer.SetDebouncePeriod(const debounce: longword);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_DEBOUNCE_PERIOD, 12);
  LEConvertUInt32To(debounce, 8, request);
  SendRequest(request, 0);
end;

function TBrickletBarometer.GetDebouncePeriod: longword;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_DEBOUNCE_PERIOD, 8);
  response := SendRequest(request, 12);
  result := LEConvertUInt32From(8, response);
end;

procedure TBrickletBarometer.SetReferenceAirPressure(const airPressure: longint);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_REFERENCE_AIR_PRESSURE, 12);
  LEConvertInt32To(airPressure, 8, request);
  SendRequest(request, 0);
end;

function TBrickletBarometer.GetChipTemperature: smallint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_CHIP_TEMPERATURE, 8);
  response := SendRequest(request, 10);
  result := LEConvertInt16From(8, response);
end;

function TBrickletBarometer.GetReferenceAirPressure: longint;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_REFERENCE_AIR_PRESSURE, 8);
  response := SendRequest(request, 12);
  result := LEConvertInt32From(8, response);
end;

procedure TBrickletBarometer.SetAveraging(const movingAveragePressure: byte; const averagePressure: byte; const averageTemperature: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_AVERAGING, 11);
  LEConvertUInt8To(movingAveragePressure, 8, request);
  LEConvertUInt8To(averagePressure, 9, request);
  LEConvertUInt8To(averageTemperature, 10, request);
  SendRequest(request, 0);
end;

procedure TBrickletBarometer.GetAveraging(out movingAveragePressure: byte; out averagePressure: byte; out averageTemperature: byte);
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_AVERAGING, 8);
  response := SendRequest(request, 11);
  movingAveragePressure := LEConvertUInt8From(8, response);
  averagePressure := LEConvertUInt8From(9, response);
  averageTemperature := LEConvertUInt8From(10, response);
end;

procedure TBrickletBarometer.SetI2CMode(const mode: byte);
var request: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_SET_I2C_MODE, 9);
  LEConvertUInt8To(mode, 8, request);
  SendRequest(request, 0);
end;

function TBrickletBarometer.GetI2CMode: byte;
var request, response: TByteArray;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_I2C_MODE, 8);
  response := SendRequest(request, 9);
  result := LEConvertUInt8From(8, response);
end;

procedure TBrickletBarometer.GetIdentity(out uid: string; out connectedUid: string; out position: char; out hardwareVersion: TVersionNumber; out firmwareVersion: TVersionNumber; out deviceIdentifier: word);
var request, response: TByteArray; i: longint;
begin
  CheckValidity;
  request := (ipcon as TIPConnection).CreateRequestPacket(self, BRICKLET_BAROMETER_FUNCTION_GET_IDENTITY, 8);
  response := SendRequest(request, 33);
  uid := LEConvertStringFrom(8, 8, response);
  connectedUid := LEConvertStringFrom(16, 8, response);
  position := LEConvertCharFrom(24, response);
  for i := 0 to 2 do hardwareVersion[i] := LEConvertUInt8From(25 + (i * 1), response);
  for i := 0 to 2 do firmwareVersion[i] := LEConvertUInt8From(28 + (i * 1), response);
  deviceIdentifier := LEConvertUInt16From(31, response);
end;

procedure TBrickletBarometer.CallbackWrapperAirPressure(const packet: TByteArray);
var airPressure: longint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  airPressure := LEConvertInt32From(8, packet);
  if (Assigned(airPressureCallback)) then begin
    airPressureCallback(self, airPressure);
  end;
end;

procedure TBrickletBarometer.CallbackWrapperAltitude(const packet: TByteArray);
var altitude: longint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  altitude := LEConvertInt32From(8, packet);
  if (Assigned(altitudeCallback)) then begin
    altitudeCallback(self, altitude);
  end;
end;

procedure TBrickletBarometer.CallbackWrapperAirPressureReached(const packet: TByteArray);
var airPressure: longint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  airPressure := LEConvertInt32From(8, packet);
  if (Assigned(airPressureReachedCallback)) then begin
    airPressureReachedCallback(self, airPressure);
  end;
end;

procedure TBrickletBarometer.CallbackWrapperAltitudeReached(const packet: TByteArray);
var altitude: longint;
begin
  if (Length(packet) <> 12) then begin
    exit; { Silently ignoring callback with wrong length }
  end;
  altitude := LEConvertInt32From(8, packet);
  if (Assigned(altitudeReachedCallback)) then begin
    altitudeReachedCallback(self, altitude);
  end;
end;

end.
